Crypto++ 7.0 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | List of all members
CCM_Final< T_BlockCipher, T_DefaultDigestSize, T_IsEncryption > Class Template Reference

CCM block cipher final implementation. More...

Inheritance diagram for CCM_Final< T_BlockCipher, T_DefaultDigestSize, T_IsEncryption >:

## Public Member Functions
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction. More...
Public Member Functions inherited from CCM_Base
std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
size_t | MinKeyLength () const
| Returns smallest valid key length. More...
size_t | MaxKeyLength () const
| Returns largest valid key length. More...
size_t | DefaultKeyLength () const
| Returns default key length. More...
size_t | GetValidKeyLength (size_t keylength) const
| Returns a valid key length for the algorithm. More...
bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs. More...
unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
lword | MaxHeaderLength () const
| Provides the maximum length of AAD that can be input. More...
lword | MaxMessageLength () const
| Provides the maximum length of encrypted data. More...
bool | NeedsPrespecifiedDataLengths () const
| Determines if data lengths must be specified prior to inputting data. More...
void | UncheckedSpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength)
Public Member Functions inherited from AuthenticatedSymmetricCipherBase
bool | IsRandomAccess () const
| Determines whether the cipher supports random access. More...
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting. More...
void | SetKey (const byte *userKey, size_t keylength, const NameValuePairs &params)
| Sets or reset the key of this object. More...
void | Restart ()
| Restart the hash. More...
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize with an IV. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes. More...
void | TruncatedFinal (byte *mac, size_t macSize)
| Computes the hash of the current message. More...
Public Member Functions inherited from AuthenticatedSymmetricCipher
virtual lword | MaxFooterLength () const
| Provides the the maximum length of AAD. More...
void | SpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength=0)
| Prespecifies the data lengths. More...
virtual void | EncryptAndAuthenticate (byte *ciphertext, byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *message, size_t messageLength)
| Encrypts and calculates a MAC in one call. More...
virtual bool | DecryptAndVerify (byte *message, const byte *mac, size_t macLength, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *ciphertext, size_t ciphertextLength)
| Decrypts and verifies a MAC in one call. More...
Public Member Functions inherited from SimpleKeyingInterface
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block. More...
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing. More...
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...

## Static Public Member Functions
static std::string | StaticAlgorithmName ()

## Additional Inherited Members
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

### template<class T_BlockCipher, int T_DefaultDigestSize, bool T_IsEncryption>
class CCM_Final< T_BlockCipher, T_DefaultDigestSize, T_IsEncryption >

CCM block cipher final implementation.

Template Parameters

  T_BlockCipher | block cipher
  T_DefaultDigestSize | default digest size, in bytes
  T_IsEncryption | direction in which to operate the cipher

Since
  Crypto++ 5.6.0

Definition at line 91 of file ccm.h.

## Member Function Documentation

## ◆ IsForwardTransformation()

template<class T_BlockCipher , int T_DefaultDigestSize, bool T_IsEncryption>

bool CCM_Final< T_BlockCipher, T_DefaultDigestSize, T_IsEncryption >::IsForwardTransformation | ( |  | ) | const
| inline virtual

Determines if the cipher is being operated in its forward direction.

Returns
  true if DIR is ENCRYPTION, false otherwise

See also
  IsForwardTransformation(), IsPermutation(), GetCipherDirection()

Implements StreamTransformation.

Definition at line 96 of file ccm.h.

The documentation for this class was generated from the following file:

- ccm.h